;    **************************************************
;    *	"SLOT.ASM" / SLOT-MACHINE PROGRAM             *
;    *	for FX-Z80(B6031A) & Ư(B6032)           *
;    *		-----------------------------         *
;    *	ASSEMBLER : 	XA80/by SYSTEM LOAD Co.,Ltd.  *
;    *	DATE      :	T.MOGI/1997.3.3               *
;    **************************************************
;
;		*** ۸  Ҳ ***
;	Ư ڶɷ- Ĥ 1Ҥ2Ҥ3Ĥ
; 	ޭ ò١ ޵Ĥ ޶޽ 
;
;	==============================================
;	                EQUATION AREA
;	==============================================
STACK	EQU	0F800h
SCR2	EQU	01Dh	   	;
PIO1	EQU	03AH	   	;PIO-ADDR
PIO1C	EQU	PIO1+1h    	;
PIO2	EQU	PIO1+2h    	;for KETASCAN
PIO2C	EQU	PIO1+3h    	;
PIO3	EQU	PIO1+4h    	;for DATA
PIO3C	EQU	PIO1+5h    	;
;
@KEYIN		EQU	0D00h	;1 ƭخ
INICLKSIO	EQU	0D06h	;Ư Ƽײ
;	------------------- ޮ --------------------
;
LPCNT	EQU	08h		;LOOP COUNT at SAME NUM
WCNT	EQU	0100h*8		;WAIT COUNT for SCAN
;
;	**********************************************
;		        MAIN_ROUTINE
;	**********************************************
;
	ORG 	8000h
MAIN:	LD	SP,STACK
	LD	A,00000000b	;ֳݦ PIO ƽ
	OUT	(SCR2),A
	LD	A,00000000b	;PIO-INITIALIZE
	OUT	(PIO1C),A	;PA_PORT as INPUT
	LD	A,00001111b
	OUT	(PIO2C),A	;PB_PORT as OUTPUT
	LD	A,11111111b
	OUT	(PIO3C),A	;PC_PORT as OUTPUT
	CALL	INICLKSIO
MAIN_2: XOR	A
	LD	(SWFLAG),A
MAIN_3: XOR	A		;RUNDUM-BUFFER CLEAR
	LD	(RANB_1),A
	LD	(RANB_2),A
	LD	(RANB_3),A
	LD	A,1
	LD	(KETA),A	;ˮ޽ݹ 
	LD	(FLAG_1),A	;ݺflag 
	LD	(FLAG_2),A	;   "
	LD	(FLAG_3),A	;   "
LOOP_1: CALL	RANDUM1		;ݽ ݸ
	CALL	RANDUM2
	CALL	RANDUM3
	LD 	HL,LPCNT
	LD	(LCNT),HL
LOOP_2: CALL	SCAN		;1st SCAN
	CALL	WAIT
	CALL	SWITCH
	CALL	SCAN		;2nd SCAN
	CALL	WAIT
	CALL	SWITCH
	CALL	SCAN		;3rd SCAN
	CALL	WAIT
	CALL	SWITCH
	LD	HL,(LCNT)
	DEC	HL
	LD	(LCNT),HL
	LD	A,H
	OR	L
	JR	NZ,LOOP_2
LOOP_9: JP	LOOP_1
;
;	---------------- SWITCH READ ------------------
;
SWITCH:
	CALL	@KEYIN
	JR	NZ,SWIT_1
	XOR	A
	LD	(SWFLAG),A
	RET
SWIT_1: LD	A,0FFh
	LD	(SWFLAG),A
	LD	B,3
	LD	HL,FLAG_1
SWIT_2:	LD	A,(HL)
	AND	A
	JR	NZ,SWIT_3
	INC	L
	DEC	B
	JR	NZ,SWIT_2
	POP	HL		;SP  ޽
	JP	MAIN_3		;MAIN  
SWIT_3:	XOR	A		;ݺfg ؾ
	LD	(HL),A
	RET
;
;	-------------------- LED SCAN -----------------
;
SCAN:	LD	A,(KETA)
	LD	C,A
	INC	A
	CP	4
	JP	NZ,SCAN_2
	LD	A,1
SCAN_2: LD	(KETA),A
	LD	B,C
	LD	A,0FEh
SCAN_4: DEC	B
	JR	Z,SCAN_6
	RLCA
	JR	SCAN_4
SCAN_6: OUT	(PIO2),A
	LD	HL,RANB_4-1
	LD	A,L
	ADD	A,C
	LD	L,A
	LD	A,(HL)
	OUT	(PIO3),A
	RET
;
;	--------------- RANDUM INCREMENT --------------
;
RANDUM1:
	LD	A,(FLAG_1)
	LD	HL,RANB_1
	JR	RAND_2
RANDUM2:
	LD	A,(FLAG_2)
	LD	HL,RANB_2
	JR	RAND_2
RANDUM3:
	LD	A,(FLAG_3)
	LD	HL,RANB_3
	JR	RAND_2
RAND_2: AND	A
	RET	Z
	LD	A,(HL)
	INC	A
	DAA			;10 ݶ
	AND	0Fh
	LD	(HL),A
	CALL	SEG		;SEGݶ
	LD	B,A
	LD	A,3
	ADD	A,L
	LD	L,A
	LD	(HL),B
	RET
;
;	-------------------- SEGMENT -------------------
;
SEG:	PUSH	DE
	LD	DE,SEGTAB
	ADD	A,E
	LD	E,A
	LD	A,0
	ADC	A,D
	LD	D,A
	LD	A,(DE)
	POP	DE
	RET
SEGTAB	DB	3Fh,06h,5Bh,4Fh		;0,1,2,3
	DB	66h,6Dh,7Dh,27h		;4,5,6,7
	DB	7Fh,6Fh,77h,7Ch		;8,9,A,B
	DB	39h,5Eh,79h,71h		;C,D,E,F
;
;	------------------- WAIT ---------------------
;
WAIT:   PUSH	BC
	PUSH	DE
	LD	D,1h
WAIT_1:	LD	BC,WCNT
WAIT_2:	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,WAIT_2
	DEC	D
	JR	NZ,WAIT_1
	POP	DE
	POP	BC
	RET
;
;	***********************************************
;	                 DATA-AREA	
;	***********************************************
	ORG	STACK
LCNT	DEFS	2
SWFLAG	DEFS    1
KETA	DEFS	1
FLAG_1	DEFS	1
FLAG_2	DEFS	1
FLAG_3	DEFS	1
RANB_1	DEFS	1
RANB_2	DEFS	1
RANB_3	DEFS	1
RANB_4	DEFS	3
;	-----------------------------------------------
	END
